function [mx_sect,hx_sect,z_sect,z_der]=cut_section_der(mx,hx,z,axis_sect,axis_val)

[n_gamma,n_alpha]=size(mx);

switch lower(axis_sect)
  case ('hx')
  disp('axis_sect=hx')
  for i_alpha=1:n_alpha
    dist=100000000;
    found=0;
    for i_gamma=2:n_gamma-1
      if (abs(hx(i_gamma,i_alpha)-axis_val) < dist)
        found=1;
        dist=abs(axis_val-hx(i_gamma,i_alpha));
        if(hx(i_gamma,i_alpha) >= axis_val)
          delta=(axis_val-hx(i_gamma,i_alpha))/(hx(i_gamma,i_alpha)-hx(i_gamma-1,i_alpha));
          z_sect(i_alpha)=z(i_gamma,i_alpha)+ ...
                (z(i_gamma,i_alpha)-z(i_gamma-1,i_alpha))*delta;
          mx_sect(i_alpha)=mx(i_gamma,i_alpha)+ ...
                (mx(i_gamma,i_alpha)-mx(i_gamma-1,i_alpha))*delta;
          hx_sect(i_alpha)=axis_val;
        else
          delta=(axis_val-hx(i_gamma,i_alpha))/(hx(i_gamma,i_alpha)-hx(i_gamma+1,i_alpha));
          z_sect(i_alpha)=z(i_gamma,i_alpha)+ ...
                (z(i_gamma,i_alpha)-z(i_gamma+1,i_alpha))*delta;
          mx_sect(i_alpha)=mx(i_gamma,i_alpha)+ ...
                (mx(i_gamma,i_alpha)-mx(i_gamma+1,i_alpha))*delta;
          hx_sect(i_alpha)=axis_val;
        end
      end
    end
    if (found ==0)
      disp('not found')
    end
  end
  for i_alpha=2:n_alpha-1
    z_der(i_alpha)=(z_sect(i_alpha+1)-z_sect(i_alpha-1))/ ...
                   (mx_sect(i_alpha+1)-mx_sect(i_alpha-1));
  end
  z_der(1)=(z_sect(2)-z_sect(1))/(mx_sect(2)-mx_sect(1));
  z_der(n_alpha)=(z_sect(n_alpha)-z_sect(n_alpha-1))/ ...
                 (mx_sect(n_alpha)-mx_sect(n_alpha-1));

  case ('mx')
  disp('axis_sect=mx')
  for i_gamma=1:n_gamma
    dist=100000000;
    found=0;
    for i_alpha=2:n_alpha-1
      if (abs(mx(i_gamma,i_alpha)-axis_val) < dist)
        found=1;
        dist=abs(axis_val-mx(i_gamma,i_alpha));
        if(mx(i_gamma,i_alpha) >= axis_val)
          delta=(axis_val-mx(i_gamma,i_alpha))/(mx(i_gamma,i_alpha)-mx(i_gamma,i_alpha-1));
          z_sect(i_gamma)=z(i_gamma,i_alpha)+ ...
                (z(i_gamma,i_alpha)-z(i_gamma,i_alpha-1))*delta;
          hx_sect(i_gamma)=hx(i_gamma,i_alpha)+ ...
                (hx(i_gamma,i_alpha)-hx(i_gamma,i_alpha-1))*delta;
          mx_sect(i_gamma)=axis_val;
        else
          delta=(axis_val-mx(i_gamma,i_alpha))/(mx(i_gamma,i_alpha)-mx(i_gamma,i_alpha+1));
          z_sect(i_gamma)=z(i_gamma,i_alpha)+ ...
                (z(i_gamma,i_alpha)-z(i_gamma,i_alpha+1))*delta;
          hx_sect(i_gamma)=hx(i_gamma,i_alpha)+ ...
                (hx(i_gamma,i_alpha)-hx(i_gamma,i_alpha+1))*delta;
          mx_sect(i_gamma)=axis_val;
        end
      end
    end
    if (found ==0)
      disp('not found')
    end
  end
  for i_gamma=2:n_gamma-1
    z_der(i_gamma)=(z_sect(i_gamma+1)-z_sect(i_gamma-1))/ ...
                   (hx_sect(i_gamma+1)-hx_sect(i_gamma-1));
  end
  z_der(1)=(z_sect(2)-z_sect(1))/(hx_sect(2)-hx_sect(1));
  z_der(n_gamma)=(z_sect(n_gamma)-z_sect(n_gamma-1))/ ...
                 (hx_sect(n_gamma)-hx_sect(n_gamma-1));


  otherwise 
    disp('wrong axis in cut_section_der')
end

