function [ax1_sect,ax2_sect,z_sect]=cut_section(ax1,ax2,z,axis_sect,axis_val)

[n_gamma,n_alpha]=size(ax1);

switch lower(axis_sect)
  case {'ax2','hx'}
  disp('axis_sect=ax2')
  for i_alpha=1:n_alpha
    dist=100000000;
    found=0;
    for i_gamma=2:n_gamma-1
      if (abs(ax2(i_gamma,i_alpha)-axis_val) < dist)
        found=1;
        dist=abs(axis_val-ax2(i_gamma,i_alpha));
        if(ax2(i_gamma,i_alpha) >= axis_val)
          delta=(axis_val-ax2(i_gamma,i_alpha))/(ax2(i_gamma,i_alpha)-ax2(i_gamma-1,i_alpha));
          z_sect(i_alpha)=z(i_gamma,i_alpha)+ ...
                (z(i_gamma,i_alpha)-z(i_gamma-1,i_alpha))*delta;
          ax1_sect(i_alpha)=ax1(i_gamma,i_alpha)+ ...
                (ax1(i_gamma,i_alpha)-ax1(i_gamma-1,i_alpha))*delta;
          ax2_sect(i_alpha)=axis_val;
        else
          delta=(axis_val-ax2(i_gamma,i_alpha))/(ax2(i_gamma,i_alpha)-ax2(i_gamma+1,i_alpha));
          z_sect(i_alpha)=z(i_gamma,i_alpha)+ ...
                (z(i_gamma,i_alpha)-z(i_gamma+1,i_alpha))*delta;
          ax1_sect(i_alpha)=ax1(i_gamma,i_alpha)+ ...
                (ax1(i_gamma,i_alpha)-ax1(i_gamma+1,i_alpha))*delta;
          ax2_sect(i_alpha)=axis_val;
        end
      end
    end
    if (found ==0)
      disp('not found')
    end
  end
  case {'ax1','mx'}
  disp('axis_sect=ax1')
  for i_gamma=1:n_gamma
    dist=100000000;
    found=0;
    for i_alpha=2:n_alpha-1
      if (abs(ax1(i_gamma,i_alpha)-axis_val) < dist)
        found=1;
        dist=abs(axis_val-ax1(i_gamma,i_alpha));
        if(ax1(i_gamma,i_alpha) >= axis_val)
          delta=(axis_val-ax1(i_gamma,i_alpha))/(ax1(i_gamma,i_alpha)-ax1(i_gamma,i_alpha-1));
          z_sect(i_gamma)=z(i_gamma,i_alpha)+ ...
                (z(i_gamma,i_alpha)-z(i_gamma,i_alpha-1))*delta;
          ax2_sect(i_gamma)=ax2(i_gamma,i_alpha)+ ...
                (ax2(i_gamma,i_alpha)-ax2(i_gamma,i_alpha-1))*delta;
          ax1_sect(i_gamma)=axis_val;
        else
          delta=(axis_val-ax1(i_gamma,i_alpha))/(ax1(i_gamma,i_alpha)-ax1(i_gamma,i_alpha+1));
          z_sect(i_gamma)=z(i_gamma,i_alpha)+ ...
                (z(i_gamma,i_alpha)-z(i_gamma,i_alpha+1))*delta;
          ax2_sect(i_gamma)=ax2(i_gamma,i_alpha)+ ...
                (ax2(i_gamma,i_alpha)-ax2(i_gamma,i_alpha+1))*delta;
          ax1_sect(i_gamma)=axis_val;
        end
      end
    end
    if (found ==0)
      disp('not found')
    end
  end

  otherwise 
    disp('wrong axis in cut_section')
end

