clear all
closereq
closereq
closereq

addpath /net/koko/homes/sep/biondo/MatLab/CIG/Aniso

%flag=-10000000;
flag=-1;

mygreen=[0,1,0];
myred=[1,0,0];
myblue=[0,0,1];
mycyan=[0,1,1];
mymagenta=[1,0,1];
myyellow=[1,1,0];


vp_mod=1
vs_mod=0.5

sp_par_iso(1)=1/(1*vp_mod);
ss_par_iso(1)=1/(1*vs_mod);

hx_data=-.2
%hx_data=.0
mx_data=0.
t_data=2.

n_gamma=179
gamma_0=-89
d_gamma=1

n_alpha=179
alpha_0=-89
d_alpha=1


for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    alpha(i_gamma,i_alpha)=alpha_0+(i_alpha-1)*d_alpha;
    gamma(i_gamma,i_alpha)=gamma_0+(i_gamma-1)*d_gamma;
  end
end


[z_ang_gen_iso,mx_ang_gen_iso,hx_ang_gen_iso]=gen_surf_ang(@s_cwv,sp_par_iso,ss_par_iso,t_data,mx_data,hx_data,gamma,alpha,flag);

[min_z_ang,max_z_ang,min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang]=max_min_zmx(z_ang_gen_iso,mx_ang_gen_iso,hx_ang_gen_iso,flag);

min_mx_ang=-1;
max_mx_ang=1;

axis_imp_ang=[min_mx_ang,max_mx_ang,min_hx_ang,max_hx_ang,min_z_ang,1.3*max_z_ang]


[mx_sect_iso,hx_sect_iso,z_sect_iso]=cut_section(mx_ang_gen_iso,hx_ang_gen_iso,z_ang_gen_iso,'hx',0.);

az=0
el=0
[hfig_sect_iso,haxis_sect_iso,hplot_sect_iso]=basic_line(mx_sect_iso,hx_sect_iso,z_sect_iso,'Mx (km)','Mh (km)','Depth (km)','',axis_imp_ang,myblue,1,1,az,el);

fid=fopen('/net/l-mumu/scr1/daniel/Matlab/psout.H@','w','ieee-be');
fwrite(fid,z_sect_iso,'float32'); 
fclose(fid);
fid=fopen('/net/l-mumu/scr1/daniel/Matlab/psout2.H@','w','ieee-be');
fwrite(fid,mx_sect_iso,'float32');
fid=fopen('/net/l-mumu/scr1/daniel/Matlab/out.H@','w','ieee-be');   
fclose(fid);

